;-----------------------------------------------------------------------------
func put_image ;//////////////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
; EAX = x
; EBX = Y
; ECX = width
; EDX = height
; ESI = input  image (RAW)
;-----------------------------------------------------------------------------
	pushad
	imul	ebx,800
	add	eax,ebx
	lea	edi,[GRAPH_BUFFER1+eax*3]
	mov	eax,800
	sub	eax,ecx
	mov	ebx,edx
	lea	edx,[eax*3]
	cld
  .lp1: push	ecx
  .lp2: movsw
	movsb
	loop	.lp2
	pop	ecx
	add	edi,edx
	dec	ebx
	jnz	.lp1
	popad
	ret
endf

;-----------------------------------------------------------------------------
func put_image_transp ;//////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
; EAX = x
; EBX = Y
; ESI = input  image (RAW)
;-----------------------------------------------------------------------------
	pushad
	imul	ebx,800
	add	eax,ebx
	lea	edi,[GRAPH_BUFFER1+eax*3]
	mov	eax,800
	sub	eax,ecx
	mov	ebx,edx
	lea	edx,[eax*3]
	cld
  .lp1: push	ecx
  .lp2: mov	eax,[esi]
	and	eax,0x00FFFFFF
	cmp	eax,0x00FF00FF
	je	@f
	rol	eax,8
	mov	al,[edi+3]
	ror	eax,8
	mov	[edi],eax
    @@: add	esi,3
	add	edi,3
	loop	.lp2
	pop	ecx
	add	edi,edx
	dec	ebx
	jnz	.lp1
	popad
	ret
endf

;-----------------------------------------------------------------------------
func draw_string ;////////////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
; EBP = pointer to font data
;-----------------------------------------------------------------------------
  .lp1: movzx	ebx,byte[esi]
	cmp	bl,0
	je	.lp2
	inc	esi
	push	esi edi
	mov	eax,[ebp+ebx*4]
	mov	ax,[ebp-2]
	push	eax
	mov	esi,[@LDATA+0x1D+28*13]
	mov	edi,@LDATA+0x00010000
	mov	[edi-4],eax
	movzx	eax,word[ebp+ebx*4]
	movzx	ebx,word[ebp-4]
	call	getimg
	movzx	ebx,word[esp+4+2]
	movzx	ecx,word[esp+4]
	call	transp_blt ; mcall 7,@LDATA+0x00010000,<20,60>,<0,0>
	pop	eax
	shr	eax,16
	inc	eax
	add	[esp+2],ax
	pop	edi esi
	jmp	.lp1
  .lp2: ret
endf

;-----------------------------------------------------------------------------
func draw_button ;////////////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
; EBX = pointer to button data
; EBP = pointer to font data
;-----------------------------------------------------------------------------
  .lp1: movzx	ebx,byte[esi]
	cmp	bl,0
	je	.lp2
	inc	esi
	push	esi edi
	mov	eax,[ebp+ebx*4]
	mov	ax,[ebp-2]
	push	eax
	mov	esi,[@LDATA+0x1D+28*13]
	mov	edi,@LDATA+0x00010000
	mov	[edi-4],eax
	movzx	eax,word[ebp+ebx*4]
	movzx	ebx,word[ebp-4]
	call	getimg
	movzx	ebx,word[esp+4+2]
	movzx	ecx,word[esp+4]
	call	transp_blt ; mcall 7,@LDATA+0x00010000,<20,60>,<0,0>
	pop	eax
	shr	eax,16
	inc	eax
	add	[esp+2],ax
	pop	edi esi
	jmp	.lp1
  .lp2: ret
endf

;-----------------------------------------------------------------------------
func transp_blt ;/////////////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
	push	edi ecx ebx
	movzx	ecx,word[edi-4]
  .lp1: push	ecx
	mov	ecx,[esp+12]
	movzx	ecx,word[ecx-2]
  .lp2: push	ecx
	mov	edx,[edi]
	add	edi,3
	and	edx,0x00FFFFFF
	cmp	edx,0x00FF00FF
	je	@f
	cmp	edx,0x00FF00FE
	je	@f
	mcall	1,,[esp+12]
    @@: pop	ecx
	inc	ebx
	loop	.lp2
	pop	ecx
	mov	ebx,[esp]
	inc	dword[esp+4]
	loop	.lp1
	pop	ebx ecx edi
	ret
endf

;-----------------------------------------------------------------------------
func getimg ;/////////////////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
; EAX = x
; EBX = Y
; ESI = input  image (RAW)
; EDI = output image (RAW)
;-----------------------------------------------------------------------------
	push	esi edi
	movzx	ecx,word[esi-2] ; input width
	imul	ecx,ebx
	add	ecx,eax
	lea	ecx,[ecx*3]
	movzx	eax,word[esi-2] ; input width
	add	esi,ecx
	movzx	ecx,word[edi-2] ; output width
	sub	eax,ecx
	lea	edx,[eax*3]
	movzx	ebx,word[edi-4] ; output height
	cld
	jz	.lp3
  .lp1: push	ecx
  .lp2: movsw
	movsb
	loop	.lp2
	pop	ecx
	add	esi,edx
	dec	ebx
	jnz	.lp1
	pop	edi esi
	ret
  .lp3: imul	ecx,ebx
	lea	ecx,[ecx*3]
	rep	movsb
	pop	edi esi
	ret
endf

;-----------------------------------------------------------------------------
func convert_image ;//////////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
; EBP = input  image (BMP)
; EDI = output image (RAW)
;-----------------------------------------------------------------------------
 dwps equ esp+4*0
 bps  equ esp+4*1
 sop  equ esp+4*2
 eop  equ esp+4*3
 eos  equ esp+4*4
;-----------------------------------------------------------------------------
	sub	esp,4*5
	movzx	eax,word[ebp+28]
	mul	dword [ebp+18]
	mov	ebx,32
	div	ebx
	test	edx,edx
	je	.noaddword
	inc	eax
  .noaddword:
	mov	[dwps],eax  ;dwps-doublewords per string
	shl	eax,2
	mov	[bps],eax   ;bps-bytes per string

	cmp	dword[ebp+34],0
	jne	.yespicsize  ;if picture size is defined
	mul	dword[ebp+22]
	mov	[ebp+34],eax

  .yespicsize:
	mov	eax,ebp
	add	eax,[ebp+10]
	mov	[sop],eax   ;sop-start of picture in file
	add	eax,[ebp+34]
	mov	[eop],eax   ;eop-end of picture in file
	mov	eax,[ebp+18]
	mov	ebx,3
	mul	ebx		;3x pixels in eax

	mov	esi,[eop]
	sub	esi,[bps]


  .nextstring:
	push	edi
	cmp	word[ebp+28],24
	jne	.convertno32

	mov	ecx,[4+dwps]
	cld
	rep	movsd
  .convert1:
	pop	edi
	sub	esi,[bps]
	cmp	esi,[sop]
	jb	.nomorestring
	sub	esi,[bps]
	add	edi,eax
	jmp	.nextstring

  .nomorestring:
	add	esp,4*5
	ret

  .convertno32:
	mov	ebx,ebp
	add	ebx,[ebp+14]
	add	ebx,14		;start of color table
	push	esi
	add	esi,[8+bps]
	mov	[8+eos],esi
	pop	esi
  .nextelem:
	push	eax
	movzx	eax,byte[esi]
;        cmp     word[ebp+28],4
;        je      .convert4bpp
	call	.converttable
  .convert2:
	pop	eax
	inc	esi
	cmp	esi,[4+eos]
	jae	.convert1
	add	edi,3
	jmp	.nextelem

;  .convert4bpp:
;        shl     ax,4
;        shr     al,4
;        push    ax
;        movzx   eax,ah
;        call    .converttable
;        add     edi,3
;        pop     ax
;        movzx   eax,al
;        call    .converttable
;        jmp     .convert2

  .converttable:
	pushd	[ebx+eax*4]
	popd	[edi]
	ret
endf

;-----------------------------------------------------------------------------
func transp_combine ;/////////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
    @@: mov	eax,[esi]
	and	eax,0x00FFFFFF
	cmp	eax,0x00FF00FF
	je	.lp1
	rol	eax,8
	mov	al,[edi+3]
	ror	eax,8
	mov	[edi],eax
  .lp1: add	esi,3
	add	edi,3
	loop	@b
	ret
endf