;-----------------------------------------------------------------------------
;::::: FEED THE SNAKE : ORIGINAL VERSION 1.3 :::::::::::::::::::::::::::::::::
;-----------------------------------------------------------------------------
; MenuetOS assembler port of popular RealApex game (originally shareware)
;  Coding (c) mike.dld
;  Graphics & levels design (c) RealApex
;-----------------------------------------------------------------------------

include 'macros.inc'

header '01',1,@START,@END,0x01300000,@STACK+0x0200,0,0

purge mov

;-----------------------------------------------------------------------------
section @START ;::::: CODE SECTION :::::::::::::::::::::::::::::::::::::::::::
;-----------------------------------------------------------------------------

	mcall	40,00100101b

	call	load_levels
	call	load_graphics
	call	generate_field
  red:
	call	draw_window
	call	[draw_func]
  still:
	call	[man_func]
	jmp	still

;-----------------------------------------------------------------------------
  button:
	mcall	17
	shr	eax,8
	sub	eax,2
	shl	eax,4
	mov	ebx,[cur_buttons]
	call	dword[ebx+eax]
	jmp	still

;-----------------------------------------------------------------------------
func draw_window ;////////////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
	mcall	12,1
	mcall	0,<0,800-1>,<0,600-1>,0x00000000,0x01000000,0
	mcall	12,2
	ret
endf
;-----------------------------------------------------------------------------

include 'man_menu.asm'
include 'man_play.asm'

include 'common.asm'
include 'graph.asm'

include 'snake_man.asm'
include 'field_man.asm'

;-----------------------------------------------------------------------------
section @DATA ;::::: INITIALIZED DATA SECTION ::::::::::::::::::::::::::::::::
;-----------------------------------------------------------------------------

draw_func   dd draw_menu
man_func    dd func_manmenu
cur_buttons dd buttons_menu

;res_start dd ?

; 0 11 22 33 44 55 66 77 79 1 2 3 4 5 6 7 8 9 10 12 13
level dd 28*12

finfo:
  dd 0,0,-1,?,@OSMEM
  rb 256

dw 0,53
font1:
times 32 dw 30,30
dw 0,20
times 65-33 dw 30,30
dw 1153,30,1183,29,1215,28,1245,30,1276,28,1304,25,1332,30,1363,26 ; ABCDEFGH
dw 1392,16,1410,21,1432,33,1468,25,1495,44,1542,28,1571,31,1606,28 ; IJKLMNOP
dw 1636,34,1672,26,1701,28,1731,28,1761,28,1792,32,1826,43,1871,29 ; QRSTUVWX
dw 1902,30,1934,31 ; YZ
times 127-65-28 dw 30,30

dw 53,53
font2:
times 32 dw 30,30
dw 0,20
times 65-33 dw 30,30
dw 1153,30,1183,29,1215,28,1245,30,1276,28,1304,25,1332,30,1363,26 ; ABCDEFGH
dw 1392,16,1410,21,1432,33,1468,25,1495,44,1542,28,1571,31,1606,28 ; IJKLMNOP
dw 1636,34,1672,26,1701,28,1731,28,1761,28,1792,32,1826,43,1871,29 ; QRSTUVWX
dw 1902,30,1934,31 ; YZ
times 127-65-28 dw 30,30

macro BTN a,b,c,d,e,f {
 dd a,b
 dw c,d,e,f }

buttons_menu:
  BTN func_newgame     ,menu_newgame	 ,408,173+60*0,410+260,165+48+60*0
  BTN func_loadgame    ,menu_loadgame	 ,408,173+60*1,410+278,165+48+60*1
  BTN func_highscores  ,menu_highscores  ,408,173+60*2,410+299,165+48+60*2
  BTN func_options     ,menu_options	 ,408,173+60*3,410+198,165+48+60*3
  BTN func_instructions,menu_instructions,408,173+60*4,410+327,165+48+60*4
  BTN func_homepage    ,menu_homepage	 ,408,173+60*5,410+275,165+48+60*5
  BTN func_exit        ,menu_exit	 ,408,173+60*6,410+108,165+48+60*6
  db 0

skin_ofs:
  dd	-1, 6*20, 2*20, 9*20
  dd 10*20,   -1, 7*20, 0*20
  dd  3*20,11*20,   -1, 4*20
  dd  5*20, 1*20, 8*20,   -1

active_menu db -1,0,0,0
active_btns db 0

sz file_levels	,<'/HD/1/COMPO/SNAKE/LEVELS.LEV'  ,0>
sz file_resource,<'/HD/1/COMPO/SNAKE/RESOURCE.FTS',0>

sz menu_newgame     ,<'NEW GAME'    ,0>
sz menu_loadgame    ,<'LOAD GAME'   ,0>
sz menu_highscores  ,<'HIGH SCORES' ,0>
sz menu_options     ,<'OPTIONS'     ,0>
sz menu_instructions,<'INSTRUCTIONS',0>
sz menu_homepage    ,<'HOME PAGE'   ,0>
sz menu_exit	    ,<'EXIT'	    ,0>

;-----------------------------------------------------------------------------
section @UDATA ;::::: UNINITIALIZED DATA SECTION :::::::::::::::::::::::::::::
;-----------------------------------------------------------------------------

DIR_NUM = 2

; Snake structure as follows:
;  -12 byte  - snake length needed to reach
;  -11 byte  - snake started moving (0..1)
;  -10 word  - snake start position (byte[x],byte[y])
;  -8  dword - pointer to another snake data
;  -4  byte  - snake number (0..1)
;  -3  byte  - snake respawn stage (0..15)
;  -2  byte  - snake moving stage (0..19)
;  -1  byte  - snake length (3..102)
;  +0  word  - (byte[x],byte[y]) coordinates array
;  first 3 units aren't counted so 3+99=102+1[fore-head]+1[post-tail]
db 0,0;,0,0
dw 0x171D
dd snake2
db 0,0,0,3;+99
snake1:
dw 0x171D
dw 0x181D
dw 0x191D,0x1A1D,0x1B1D,0x1C1D,0x1D1D,0x1E1D,0x1F1D,0x101D
dw 0x211D,0x221D,0x231D,0x241D,0x251D,0x261D,0x271D,0x281D
dw 0x291D,0x2A1D,0x2B1D,0x2C1D,0x2D1D,0x2E1D,0x2F1D,0x201D
dw 0x311D,0x321D,0x331D,0x341D,0x351D,0x361D,0x371D,0x381D
dw 0x391D,0x3A1D,0x3B1D,0x3C1D,0x3D1D,0x3E1D,0x3F1D,0x301D
dw 0x411D,0x421D,0x431D,0x441D,0x451D,0x461D,0x471D,0x481D
dw 0x491D,0x4A1D,0x4B1D,0x4C1D,0x4D1D,0x4E1D,0x4F1D,0x401D
dw 0x511D,0x521D,0x531D,0x541D,0x551D,0x561D,0x571D,0x581D
dw 0x591D,0x5A1D,0x5B1D,0x5C1D,0x5D1D,0x5E1D,0x5F1D,0x501D
dw 0x611D,0x621D,0x631D,0x641D,0x651D,0x661D,0x671D,0x681D
dw 0x691D,0x6A1D,0x6B1D,0x6C1D,0x6D1D,0x6E1D,0x6F1D,0x601D
dw 0x711D,0x721D,0x731D,0x741D,0x751D,0x761D,0x771D,0x781D
dw 0x791D,0x7A1D,0x7B1D,0x7C1D,0x7D1D,0x7E1D

dw 0
TEL_START = $-snake1
rw 50

DIR_START = $-snake1

; 00b - left
; 01b - top
; 10b - right
; 11b - bottom
.dir db 01b
     rb DIR_NUM-1 ; DIR_LST bytes for dir-buffer
     db ?	  ; 1 byte for last dir, 1 byte for dirs in buffer

db 0,0;,0,0
dw 0x170A
dd snake1
db 1,0,0,3;+99
snake2:
dw 0x170A
dw 0x180A
dw 0x190A,0x1A0A,0x1B0A,0x1C0A,0x1D0A,0x1E0A,0x1F0A,0x100A
dw 0x210A,0x220A,0x230A,0x240A,0x250A,0x260A,0x270A,0x280A
dw 0x290A,0x2A0A,0x2B0A,0x2C0A,0x2D0A,0x2E0A,0x2F0A,0x200A
dw 0x310A,0x320A,0x330A,0x340A,0x350A,0x360A,0x370A,0x380A
dw 0x390A,0x3A0A,0x3B0A,0x3C0A,0x3D0A,0x3E0A,0x3F0A,0x300A
dw 0x410A,0x420A,0x430A,0x440A,0x450A,0x460A,0x470A,0x480A
dw 0x490A,0x4A0A,0x4B0A,0x4C0A,0x4D0A,0x4E0A,0x4F0A,0x400A
dw 0x510A,0x520A,0x530A,0x540A,0x550A,0x560A,0x570A,0x580A
dw 0x590A,0x5A0A,0x5B0A,0x5C0A,0x5D0A,0x5E0A,0x5F0A,0x500A
dw 0x610A,0x620A,0x630A,0x640A,0x650A,0x660A,0x670A,0x680A
dw 0x690A,0x6A0A,0x6B0A,0x6C0A,0x6D0A,0x6E0A,0x6F0A,0x600A
dw 0x710A,0x720A,0x730A,0x740A,0x750A,0x760A,0x770A,0x780A
dw 0x790A,0x7A0A,0x7B0A,0x7C0A,0x7D0A,0x7E0A

dw 0
rw 50

.dir db 01b
     rb DIR_NUM-1
     db ?

levels: rb 100 shl 10 ; 100 Kbytes

rnd_field: rb 40*29

;-----------------------------------------------------------------------------
section @END ;::::: IMAGE END ::::::::::::::::::::::::::::::::::::::::::::::::
;-----------------------------------------------------------------------------

;-----------------------------------------------------------------------------
section @STACK ;::::: APPLICATION STACK :::::::::::::::::::::::::::::::::::::::
;-----------------------------------------------------------------------------

rb 0x200

;-----------------------------------------------------------------------------
section @OSMEM ;::::: MEMORY FOR OPERATING SYSTEM ::::::::::::::::::::::::::::
;-----------------------------------------------------------------------------

rb 0x400

;-----------------------------------------------------------------------------
section @LDATA ;::::: RUN-TIME LOADABLE DATA :::::::::::::::::::::::::::::::::
;-----------------------------------------------------------------------------

TELEPORTS_LIST = @LDATA+0x00020000
GRAPH_BUFFER1  = @LDATA+0x00020000+200+800*600*3
GRAPH_BUFFER2  = @LDATA+0x00020000+200+800*600*3+800*600*3
